package nu.zoom.checked.client;

import java.io.IOException;
import java.net.StandardProtocolFamily;
import java.net.UnixDomainSocketAddress;
import java.nio.ByteBuffer;
import java.nio.channels.SocketChannel;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.UUID;

public class Main {
    public static void main(String[] args) throws IOException {
        new Main().run();
    }

    private void run() {
        try (var clientChannel = SocketChannel.open(StandardProtocolFamily.UNIX)) {
            var serverPath = Path.of("/tmp").resolve("udsserver.sock") ;
            var serverAddress = UnixDomainSocketAddress.of(serverPath);
            clientChannel.connect(serverAddress);

            var clientMessage = "Hello world from Java";

            var messageBytes = clientMessage.getBytes(StandardCharsets.UTF_8);
            var messageBuffer = ByteBuffer.allocate(400);
            messageBuffer.put((byte) messageBytes.length);
            messageBuffer.put(messageBytes);
            messageBuffer.flip();
            while  (messageBuffer.hasRemaining()) {
                clientChannel.write(messageBuffer);
            }
        } catch (IOException e) {
			e.printStackTrace();
		}
	}

    private static void sendMessage(String clientMessage, SocketChannel clientChannel) throws IOException {
        var messageBytes = clientMessage.getBytes(StandardCharsets.UTF_8);
        var messageBuffer = ByteBuffer.allocate(400);
        messageBuffer.put((byte) messageBytes.length);
        messageBuffer.put(messageBytes);
        messageBuffer.flip();
        while  (messageBuffer.hasRemaining()) {
            clientChannel.write(messageBuffer);
        }
    }

    static class MessageToLongException extends Exception {}
}